#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <unistd.h>
#include "parsexml.h"

#define PORT 8080

int main(int argc, char** argv)
{
	int sock_fd, addrlen, msglen; 

	struct sockaddr_in clientAddr, *result;
	char key[258],value[256*1024+2],buffer[257*1024],*message,*err;
	char *operation = (char *)malloc(sizeof(char)*7);


	if( (sock_fd = socket(AF_INET , SOCK_STREAM , 0)) == 0) {   //Connection oriented Socket, choose protocol automatically (0)
		
		printf("%s",toRespXML("Network Error: Could not create socket"));
		exit(1);
	} 

	clientAddr.sin_family = AF_INET;
	clientAddr.sin_port = htons(PORT);
	clientAddr.sin_addr.s_addr = INADDR_ANY; //inet_addr("localhost");// inet_aton("localhost",&(clientAddr.sin_addr));
	memset(&(clientAddr.sin_zero), '\0', 8); 
    addrlen = sizeof(struct sockaddr_in);   

	if(	connect(sock_fd, (struct sockaddr *)&clientAddr, addrlen)<0) {  
		printf("%s",toRespXML("Network Error: Could not connect"));
		exit(1);
	} 

	FILE *fp;
    if (argc >= 2){
        fp = fopen(argv[1], "r");
        if (fp==NULL){
            printf("ERROR:File doesn't exist\n");
            return -1;
        }
    }
	FILE *outFp;
	if(argc>=3)
		outFp = fopen(argv[2],"w+");
	while(1){
		// batch mode
		if(argc >= 2) { 
			if(fscanf(fp,"%[^,],",operation)==EOF)
				break;
			if(!strcmp(operation,"put") || !strcmp(operation,"PUT"))
				fscanf(fp,"%[^,],%[^\n]\n",key,value);
			else
				fscanf(fp,"%[^\n]\n",key);
			// printf("%s,%s,%s\n",operation,key,value);

			if(!strcmp(operation,"get") || !strcmp(operation,"GET"))
				strcpy(operation,"getreq");
			else if(!strcmp(operation,"put") || !strcmp(operation,"PUT"))
				strcpy(operation,"putreq");
			else if(!strcmp(operation,"del") || !strcmp(operation,"DEL"))
				strcpy(operation,"delreq");
			else {
				printf("Invalid Choice, Please try again\n");
				continue;
			}

			message = toXML(operation,key,value);
			write(sock_fd, message, strlen(message));
			msglen = read(sock_fd, buffer, 257*1024);
			buffer[msglen] = '\0';
			extractRespXml(outFp,buffer);
			if(argc>=4)
				if(!strcmp(argv[3],"-p"))
					puts(buffer);
		} 
		// Interactive mode
		else {
			printf("Enter operation\n GET\tPUT\tDEL\n");
			scanf("%s",operation);
			if(!strcmp(operation,"get") || !strcmp(operation,"GET")){
				printf("Enter Key\n");
				strcpy(operation,"getreq");
				scanf("%s",key);
			} else if(!strcmp(operation,"put") || !strcmp(operation,"PUT")){
				printf("Enter Key and Value\n");
				strcpy(operation,"putreq");
				scanf("%s",key);
				getchar();
				scanf("%[^\n]s",value);
			} else if(!strcmp(operation,"del") || !strcmp(operation,"DEL")){
				printf("Enter Key\n");
				strcpy(operation,"delreq");
				scanf("%s",key);			
			} else {
				printf("Invalid Choice, Please try again\n");
				continue;
			}

			message = toXML(operation,key,value);
			write(sock_fd, message, strlen(message));

			msglen = read(sock_fd, buffer, 257*1024);
			buffer[msglen] = '\0';
			puts(buffer);
		}
	}
	fclose(outFp);
	return 0;
}